com.google.zxing

## Class RGBLuminanceSource

- java.lang.Object
- - com.google.zxing.LuminanceSource
  - - com.google.zxing.RGBLuminanceSource

-     public final class RGBLuminanceSource
      extends LuminanceSource

  This class is used to help decode images from files which arrive as RGB data from an ARGB pixel array. It does not support rotation.
  Author:
    dswitkin@google.com (Daniel Switkin), Betaminos

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `RGBLuminanceSource(int width, int height, int[] pixels)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `LuminanceSource` | `crop(int left, int top, int width, int height)` Returns a new object with cropped image data.
    `byte[]` | `getMatrix()` Fetches luminance data for the underlying bitmap.
    `byte[]` | `getRow(int y, byte[] row)` Fetches one row of luminance data from the underlying platform's bitmap.
    `boolean` | `isCropSupported()`

    - ### Methods inherited from class com.google.zxing.LuminanceSource

      `getHeight, getWidth, invert, isRotateSupported, rotateCounterClockwise, rotateCounterClockwise45, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### RGBLuminanceSource

          public RGBLuminanceSource(int width,
                                    int height,
                                    int[] pixels)

  - ### Method Detail

    - #### getRow

          public byte[] getRow(int y,
                               byte[] row)

      Description copied from class: `LuminanceSource`
      Fetches one row of luminance data from the underlying platform's bitmap. Values range from 0 (black) to 255 (white). Because Java does not have an unsigned byte type, callers will have to bitwise and with 0xff for each value. It is preferable for implementations of this method to only fetch this row rather than the whole image, since no 2D Readers may be installed and getMatrix() may never be called.
      Specified by:
        `getRow` in class `LuminanceSource`
      Parameters:
        `y` - The row to fetch, which must be in [0,getHeight())
        `row` - An optional preallocated array. If null or too small, it will be ignored. Always use the returned object, and ignore the .length of the array.
      Returns:
        An array containing the luminance data.

    - #### getMatrix

          public byte[] getMatrix()

      Description copied from class: `LuminanceSource`
      Fetches luminance data for the underlying bitmap. Values should be fetched using: `int luminance = array[y * width + x] & 0xff`
      Specified by:
        `getMatrix` in class `LuminanceSource`
      Returns:
        A row-major 2D array of luminance values. Do not use result.length as it may be larger than width * height bytes on some platforms. Do not modify the contents of the result.

    - #### isCropSupported

          public boolean isCropSupported()

      Overrides:
        `isCropSupported` in class `LuminanceSource`
      Returns:
        Whether this subclass supports cropping.

    - #### crop

          public LuminanceSource crop(int left,
                                      int top,
                                      int width,
                                      int height)

      Description copied from class: `LuminanceSource`
      Returns a new object with cropped image data. Implementations may keep a reference to the original data rather than a copy. Only callable if isCropSupported() is true.
      Overrides:
        `crop` in class `LuminanceSource`
      Parameters:
        `left` - The left coordinate, which must be in [0,getWidth())
        `top` - The top coordinate, which must be in [0,getHeight())
        `width` - The width of the rectangle to crop.
        `height` - The height of the rectangle to crop.
      Returns:
        A cropped version of this object.

Copyright © 2007–2018. All rights reserved.